<?php
/*-----------------------------------------------------------------
* 	ID:						banner_statistics.php
* 	Letzter Stand:			v2.2 R365
* 	zuletzt geaendert von:	akausch
* 	Datum:					2012/07/03
*
* 	Copyright (c) since 2010 commerce:SEO by Webdesign Erfurt
* 	http://www.commerce-seo.de
* ------------------------------------------------------------------
* 	based on:
* 	(c) 2000-2001 The Exchange Project  (earlier name of osCommerce)
* 	(c) 2002-2003 osCommerce - www.oscommerce.com
* 	(c) 2003     nextcommerce - www.nextcommerce.org
* 	(c) 2005     xt:Commerce - www.xt-commerce.com
* 	Released under the GNU General Public License
* ---------------------------------------------------------------*/

require('includes/application_top.php');

define('DB_CACHE', FALSE);

$banner_extension = xtc_banner_image_extension();

// check if the graphs directory exists
$dir_ok = false;
if ( (function_exists('imagecreate')) && ($banner_extension) ) {
if (is_dir(DIR_WS_IMAGES . 'graphs')) {
  if (is_writeable(DIR_WS_IMAGES . 'graphs')) {
	$dir_ok = true;
  } else {
	$messageStack->add(ERROR_GRAPHS_DIRECTORY_NOT_WRITEABLE, 'error');
  }
} else {
  $messageStack->add(ERROR_GRAPHS_DIRECTORY_DOES_NOT_EXIST, 'error');
}
}

$banner_query = xtc_db_query("select banners_title from " . TABLE_BANNERS . " where banners_id = '" . $_GET['bID'] . "'");
$banner = xtc_db_fetch_array($banner_query);

$years_array = array();
$years_query = xtc_db_query("select distinct year(banners_history_date) as banner_year from " . TABLE_BANNERS_HISTORY . " where banners_id = '" . $_GET['bID'] . "'");
while ($years = xtc_db_fetch_array($years_query)) {
$years_array[] = array('id' => $years['banner_year'],
					   'text' => $years['banner_year']);
}

$months_array = array();
for ($i=1; $i<13; $i++) {
$months_array[] = array('id' => $i,
						'text' => strftime('%B', mktime(0,0,0,$i)));
}

$type_array = array(array('id' => 'daily',
						'text' => STATISTICS_TYPE_DAILY),
				  array('id' => 'monthly',
						'text' => STATISTICS_TYPE_MONTHLY),
				  array('id' => 'yearly',
						'text' => STATISTICS_TYPE_YEARLY));
						
require(DIR_WS_INCLUDES.'header.php');
?>
<table class="outerTable" cellspacing="0" cellpadding="0">
  <tr>
    <td class="boxCenter" width="100%" valign="top">
	 <table border="0" width="100%" cellspacing="0" cellpadding="2">
      <tr>
        <td width="100%">
			<table class="table_pageHeading" border="0" width="100%" cellspacing="0" cellpadding="0">
	   			 <tr>
	     		<td class="pageHeading"><?php echo HEADING_TITLE; ?></td>
			  </tr>
			</table>
			<table border="0" width="100%" cellspacing="0" cellpadding="0">
          <tr>
            <td class="main" align="right"><?php echo xtc_draw_form('year', FILENAME_BANNER_STATISTICS, '', 'get'); ?>
				<?php echo TITLE_TYPE . ' ' . xtc_draw_pull_down_menu('type', $type_array, (($_GET['type']) ? $_GET['type'] : 'daily'), 'onChange="this.form.submit();"'); ?>
				<noscript><input type="submit" value="GO"></noscript><br />
			<?php
			  switch ($_GET['type']) {
			    case 'yearly': break;
			    case 'monthly':
			      echo TITLE_YEAR . ' ' . xtc_draw_pull_down_menu('year', $years_array, (($_GET['year']) ? $_GET['year'] : date('Y')), 'onChange="this.form.submit();"') . '<noscript><input type="submit" value="GO"></noscript>';
			      break;
			    default:
			    case 'daily':
			      echo TITLE_MONTH . ' ' . xtc_draw_pull_down_menu('month', $months_array, (($_GET['month']) ? $_GET['month'] : date('n')), 'onChange="this.form.submit();"') . '<noscript><input type="submit" value="GO"></noscript><br />' . TITLE_YEAR . ' ' . xtc_draw_pull_down_menu('year', $years_array, (($_GET['year']) ? $_GET['year'] : date('Y')), 'onChange="this.form.submit();"') . '<noscript><input type="submit" value="GO"></noscript>';
			      break;
			  }
			?>
            </td>
          <?php echo xtc_draw_hidden_field('page', $_GET['page']) . xtc_draw_hidden_field('bID', $_GET['bID']); 
          echo '</form>';
          ?></tr>
        </table></td>
      </tr>
      <tr>
        <td><?php echo xtc_draw_separator('pixel_trans.gif', '1', '10'); ?></td>
      </tr>
      <tr>
        <td align="center">
			<?php
			  if ( (function_exists('imagecreate')) && ($dir_ok) && ($banner_extension) ) {
			    $banner_id = $_GET['bID'];
			    switch ($_GET['type']) {
			      case 'yearly':
			        include(DIR_WS_INCLUDES . 'graphs/banner_yearly.php');
			        echo xtc_image(DIR_WS_IMAGES . 'graphs/banner_yearly-' . $banner_id . '.' . $banner_extension);
			        break;
			      case 'monthly':
			        include(DIR_WS_INCLUDES . 'graphs/banner_monthly.php');
			        echo xtc_image(DIR_WS_IMAGES . 'graphs/banner_monthly-' . $banner_id . '.' . $banner_extension);
			        break;
			      default:
			      case 'daily':
			        include(DIR_WS_INCLUDES . 'graphs/banner_daily.php');
			        echo xtc_image(DIR_WS_IMAGES . 'graphs/banner_daily-' . $banner_id . '.' . $banner_extension);
			        break;
			    }
			?>
          <table border="0" width="600" cellspacing="0" cellpadding="2">
            <tr class="dataTableHeadingRow">
             <td class="dataTableHeadingContent"><?php echo TABLE_HEADING_SOURCE; ?></td>
             <td class="dataTableHeadingContent" align="right"><?php echo TABLE_HEADING_VIEWS; ?></td>
             <td class="dataTableHeadingContent" align="right"><?php echo TABLE_HEADING_CLICKS; ?></td>
           </tr>
			<?php
			    for ($i = 0, $n = sizeof($stats); $i < $n; $i++) {
			      echo '            <tr class="dataTableRow">' . "\n" .
			           '              <td class="dataTableContent">' . $stats[$i][0] . '</td>' . "\n" .
			           '              <td class="dataTableContent" align="right">' . number_format($stats[$i][1]) . '</td>' . "\n" .
			           '              <td class="dataTableContent" align="right">' . number_format($stats[$i][2]) . '</td>' . "\n" .
			           '            </tr>' . "\n";
			    }
			?>
          </table>
		<?php
		  } else {
		    include(DIR_WS_FUNCTIONS . 'html_graphs.php');
		    switch ($_GET['type']) {
		      case 'yearly':
		        echo xtc_banner_graph_yearly($_GET['bID']);
		        break;
		      case 'monthly':
		        echo xtc_banner_graph_monthly($_GET['bID']);
		        break;
		      default:
		      case 'daily':
		        echo xtc_banner_graph_daily($_GET['bID']);
		        break;
		    }
		  }
		?>
        </td>
      </tr>
      <tr>
        <td><?php echo xtc_draw_separator('pixel_trans.gif', '1', '10'); ?></td>
      </tr>
      <tr>
        <td class="main" align="right"><?php echo '<a class="button" onClick="this.blur();" href="' . xtc_href_link(FILENAME_BANNER_MANAGER, 'page=' . $_GET['page'] . '&bID=' . $_GET['bID']) . '">' . BUTTON_BACK . '</a>'; ?></td>
      </tr>
    </table></td>
  </tr>
</table>
<?php 
require(DIR_WS_INCLUDES . 'footer.php');
require(DIR_WS_INCLUDES . 'application_bottom.php');
